Loading...
Searching...
No Matches
QGpgME::SignEncryptJob Class Referenceabstract

An abstract base class for asynchronous combined signing and encrypting. More...

`#include <signencryptjob.h>`

Inheritance diagram for QGpgME::SignEncryptJob:
[legend]
Collaboration diagram for QGpgME::SignEncryptJob:
[legend]

## Signals

void | result (const GpgME::SigningResult &signingresult, const GpgME::EncryptionResult &encryptionresult, const QByteArray &cipherText, const QString &auditLogAsHtml=QString(), const GpgME::Error &auditLogError=GpgME::Error())
Signals inherited from QGpgME::Job
void | jobProgress (int current, int total)
void | rawProgress (const QString &what, int type, int current, int total)
QGPGME_DEPRECATED void | progress (const QString &what, int current, int total)
void | done ()

## Public Member Functions

void | setFileName (const QString &fileName)
QString | fileName () const
void | setSigners (const std::vector< GpgME::Key > &signers)
std::vector< GpgME::Key > | signers () const
void | setRecipients (const std::vector< GpgME::Key > &recipients)
std::vector< GpgME::Key > | recipients () const
void | setInputFile (const QString &path)
QString | inputFile () const
void | setOutputFile (const QString &path)
QString | outputFile () const
void | setEncryptionFlags (GpgME::Context::EncryptionFlags flags)
GpgME::Context::EncryptionFlags | encryptionFlags () const
virtual GpgME::Error | start (const std::vector< GpgME::Key > &signers, const std::vector< GpgME::Key > &recipients, const QByteArray &plainText, bool alwaysTrust=false)=0
virtual void | start (const std::vector< GpgME::Key > &signers, const std::vector< GpgME::Key > &recipients, const std::shared_ptr< QIODevice > &plainText, const std::shared_ptr< QIODevice > &cipherText=std::shared_ptr< QIODevice >(), bool alwaysTrust=false)=0
virtual std::pair< GpgME::SigningResult, GpgME::EncryptionResult > | exec (const std::vector< GpgME::Key > &signers, const std::vector< GpgME::Key > &recipients, const QByteArray &plainText, bool alwaysTrust, QByteArray &cipherText)=0
virtual void | setOutputIsBase64Encoded (bool)=0
virtual void | start (const std::vector< GpgME::Key > &signers, const std::vector< GpgME::Key > &recipients, const std::shared_ptr< QIODevice > &plainText, const std::shared_ptr< QIODevice > &cipherText=std::shared_ptr< QIODevice >(), const GpgME::Context::EncryptionFlags flags=GpgME::Context::None)=0
virtual std::pair< GpgME::SigningResult, GpgME::EncryptionResult > | exec (const std::vector< GpgME::Key > &signers, const std::vector< GpgME::Key > &recipients, const QByteArray &plainText, const GpgME::Context::EncryptionFlags flags, QByteArray &cipherText)=0
Public Member Functions inherited from QGpgME::Job
virtual QString | auditLogAsHtml () const
virtual GpgME::Error | auditLogError () const
bool | isAuditLogSupported () const
GpgME::Error | startIt ()
void | startNow ()

## Protected Member Functions

| SignEncryptJob (std::unique_ptr< SignEncryptJobPrivate >, QObject *parent)
Protected Member Functions inherited from QGpgME::Job
| Job (std::unique_ptr< JobPrivate >, QObject *parent)
| Job (QObject *parent)

## Additional Inherited Members

Public Slots inherited from QGpgME::Job
virtual void | slotCancel ()=0
Static Public Member Functions inherited from QGpgME::Job
static GpgME::Context * | context (Job *job)
Protected Attributes inherited from QGpgME::Job
const std::unique_ptr< JobPrivate > | d_ptr

## Detailed Description

An abstract base class for asynchronous combined signing and encrypting.

To use a SignEncryptJob, first obtain an instance from the CryptoBackend implementation, connect the progress() and result() signals to suitable slots and then start the operation with a call to start(). This call might fail, in which case the SignEncryptJob instance will have scheduled it's own destruction with a call to QObject::deleteLater().

Alternatively, the job can be started with startIt() after setting an input file and an output file and, optionally, signers, recipients or flags. If the job is started this way then the backend reads the input and writes the output directly from/to the specified input file and output file. In this case the cipherText value of the result signal will always be empty. This direct IO mode is currently only supported for OpenPGP. Note that startIt() does not schedule the job's destruction if starting the job failed.

After result() is emitted, the SignEncryptJob will schedule it's own destruction by calling QObject::deleteLater().

## Member Function Documentation

## exec()

virtual std::pair< GpgME::SigningResult, GpgME::EncryptionResult > QGpgME::SignEncryptJob::exec | ( | const std::vector< GpgME::Key > & | signers,
|  | const std::vector< GpgME::Key > & | recipients,
|  | const QByteArray & | plainText,
|  | const GpgME::Context::EncryptionFlags | flags,
|  | QByteArray & | cipherText )

pure virtual

Like exec but with an additional argument for EncryptionFlags for more flexibility.

Implemented in QGpgME::QGpgMESignEncryptJob.

## setEncryptionFlags()

void SignEncryptJob::setEncryptionFlags | ( | GpgME::Context::EncryptionFlags | flags | ) |

Sets the flags to use for encryption.

Defaults to `EncryptFile`.

Used if the job is started with startIt(). The `EncryptFile` flag is always assumed set.

## setFileName()

void SignEncryptJob::setFileName | ( | const QString & | fileName | ) |

Sets the file name to embed in the encryption result.

This is only used if one of the start() functions is used.

## setInputFile()

void SignEncryptJob::setInputFile | ( | const QString & | path | ) |

Sets the path of the file to encrypt.

Used if the job is started with startIt().

## setOutputFile()

void SignEncryptJob::setOutputFile | ( | const QString & | path | ) |

Sets the path of the file to write the encryption result to.

Used if the job is started with startIt().

Note
  If a file with this path exists, then the job will fail, i.e. you need to delete an existing file that shall be overwritten before you start the job.

## setOutputIsBase64Encoded()

virtual void QGpgME::SignEncryptJob::setOutputIsBase64Encoded | ( | bool |  | ) |

pure virtual

This is a hack to request BASE64 output (instead of whatever comes out normally).

Implemented in QGpgME::QGpgMESignEncryptJob.

## setRecipients()

void SignEncryptJob::setRecipients | ( | const std::vector< GpgME::Key > & | recipients | ) |

Sets the keys to use for encryption.

Used if the job is started with startIt().

## setSigners()

void SignEncryptJob::setSigners | ( | const std::vector< GpgME::Key > & | signers | ) |

Sets the keys to use for signing.

Used if the job is started with startIt().

## start() [1/3]

virtual GpgME::Error QGpgME::SignEncryptJob::start | ( | const std::vector< GpgME::Key > & | signers,
|  | const std::vector< GpgME::Key > & | recipients,
|  | const QByteArray & | plainText,
|  | bool | alwaysTrust = false )

pure virtual

Starts the combined signing and encrypting operation. signers is the list of keys to sign plainText with. recipients is a list of keys to encrypt the signed plainText to. In both lists, empty (null) keys are ignored.

If alwaysTrust is true, validity checking for the recipient keys will not be performed, but full validity assumed for all recipient keys without further checks.

Implemented in QGpgME::QGpgMESignEncryptJob.

## start() [2/3]

virtual void QGpgME::SignEncryptJob::start | ( | const std::vector< GpgME::Key > & | signers,
|  | const std::vector< GpgME::Key > & | recipients,
|  | const std::shared_ptr< QIODevice > & | plainText,
|  | const std::shared_ptr< QIODevice > & | cipherText = std::shared_ptr< QIODevice >(),
|  | bool | alwaysTrust = false )

pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

If cipherText is non-null, the ciphertext is written there. Otherwise, it will be delivered in the third argument of result().

Implemented in QGpgME::QGpgMESignEncryptJob.

## start() [3/3]

virtual void QGpgME::SignEncryptJob::start | ( | const std::vector< GpgME::Key > & | signers,
|  | const std::vector< GpgME::Key > & | recipients,
|  | const std::shared_ptr< QIODevice > & | plainText,
|  | const std::shared_ptr< QIODevice > & | cipherText = std::shared_ptr< QIODevice >(),
|  | const GpgME::Context::EncryptionFlags | flags = GpgME::Context::None )

pure virtual

Like start but with an additional argument for EncryptionFlags for more flexibility.

Implemented in QGpgME::QGpgMESignEncryptJob.

The documentation for this class was generated from the following files:

- signencryptjob.h
- signencryptjob.cpp